#![no_main]
#![no_std]
use cortex_m_semihosting::hprintln;
use hal::nrf52832_pac as pac;
use nrf52832_hal as hal;
#[allow(unused_imports)]
use panic_semihosting;
use rtfm::app;

use embedded_hal::digital::OutputPin;
use hal::gpio;
use hal::gpio::p0::*;
use hal::gpio::Level;
use hal::gpio::*;
use hal::prelude::GpioExt;

#[app(device = crate::hal::target)]
const APP: () = {
    #[init]
    fn init() {
        static mut X: u32 = 0;

        // Safe access to local `static mut` variable
        let _x: &'static mut u32 = X;

        // Cortex-M peripherals
        let _core: rtfm::Peripherals = core;

        // Device specific peripherals
        let p: pac::Peripherals = device;
        let port0 = p.P0.split();

        let mut led: P0_14<gpio::Output<PushPull>> =
            port0.p0_14.into_push_pull_output(Level::High);

        hprintln!("init").unwrap();
        loop {
            hprintln!("set_low").unwrap();

            led.set_low();
            hprintln!("set_high").unwrap();

            led.set_high();
        }

        hprintln!("init").unwrap();
    }
    #[idle]
    fn idle() -> ! {
        hprintln!("idle").unwrap();
        loop {}
    }
};
