#![no_main]
#![no_std]
use cortex_m_semihosting::hprintln;
use hal::nrf52832_pac as pac;
use nrf52832_hal as hal;
use pac::interrupt;
#[allow(unused_imports)]
use panic_semihosting;
use rtfm::app;

#[app(device = crate::hal::target)]
const APP: () = {
    #[init]
    fn init() {
        hprintln!("init").unwrap();
        rtfm::pend(interrupt::SWI0_EGU0);
    }
    #[idle]
    fn idle() -> ! {
        hprintln!("idle").unwrap();
        rtfm::pend(interrupt::SWI0_EGU0);
        loop {}
    }

    #[interrupt]
    fn SWI0_EGU0() {
        static mut TIMES: u32 = 0;
        *TIMES += 1;
        hprintln!("SWIO_EGU0 {}", TIMES).unwrap();
    }
};
