#![no_main]
#![no_std]
use cortex_m_semihosting::hprintln;
use nrf52832_hal as hal;
#[allow(unused_imports)]
use panic_semihosting;
use rtfm::app;

#[app(device = crate::hal::target)]
const APP: () = {
    #[init(spawn = [foo])]
    fn init() {
        hprintln!("init").unwrap();
        spawn.foo().unwrap();
    }

    #[task(spawn = [bar, baz])]
    fn foo() {
        hprintln!("foo").unwrap();
        spawn.bar().unwrap();
        spawn.baz().unwrap();
    }

    #[task]
    fn bar() {
        hprintln!("bar").unwrap();
    }

    #[task(priority = 2)]
    fn baz() {
        hprintln!("baz").unwrap();
    }

    extern "C" {
        fn SWI0_EGU0();
        fn SWI1_EGU1();
    }
};
